require 'digest/sha1'

# can't use constant as it gets redeclared when the require is done and so causes a warning
@dynamic_file_name="default"

def process_message message, verbose=false
	if verbose
		puts "Using language file default"
		puts "Processing message: " + message
	end

	if /^:cmd ([^ ]*)( .*)$/.match(message)
		command=$1.strip
		arguments=$2.strip

		if verbose
			puts "command: " + $1 + " args: " + arguments
		end
		case command
			when "language"
				change_language arguments, verbose
			when "ping"
				# Ping
				ping arguments, verbose
			when "get"
				get_file arguments, verbose
			when "exec"
				exec arguments, verbose
			else
				puts "Unknown command"
		end
	end
end
