require 'openssl'

# This is the site the command is hidden on
BASE_SITE = "http://kreiosc2.com"

# Also configure the list of salts below, adding more if you are likely to send more than 1 or 2 messages every 10 minutes

def gen_aliases verbose
	salts = [
		"robin",
		"wood",
		"digininja"
	];

	aliases = []

	time = Time.new
	puts "Current mins is: " + time.strftime("%M").to_s
	mins_tens = time.strftime("%M").to_s[0,1].to_i
	next_ten = ((mins_tens+1).modulo 6) * 10
	puts "Round up to next 10 is: " + next_ten.to_s 

	# Y m d h:i0
	time_next_10 = Time.utc(time.year,time.month,time.day,time.hour,next_ten,0)

	puts time_next_10

	salts.each { |salt|
		aliasx = Digest::SHA1.hexdigest(time_next_10.to_s + salt).slice(0,10)
		aliases << aliasx
	}

	if verbose
		puts "The following aliases will be tried: "
		puts aliases
	end

	return aliases
end

def shorten(url, aliasx, verbose=false)
	site="tinyurl.com"
	page="/create.php"

	if verbose
		puts "URL is: " + url
	end

	Net::HTTP.start(site, 80) { |http|
		response = http.post(page, "url=#{url}&alias=#{aliasx}")
 
		if response.code == "200"
			#puts response.read_body
			uris=URI.extract(response.read_body)
			if uris.length > 0
				preview_uris=uris.grep(/preview\.tinyurl\.com/)
				if preview_uris.length > 1
					if verbose
						puts "Preview command is " + preview_uris[0]
					end
					new_alias=preview_uris[0].gsub(/http:\/\/preview\.tinyurl\.com\//, "")
					return new_alias==aliasx
				else
					if verbose
						puts "Preview URI not found in response"
					end
				end
			else
				if verbose
					puts "No URIs found in response"
				end
			end
		else
			if verbose
				puts "Error code " + response.code + " returned from tinyurl"
			end
		end
		return false
	}
end

def send_command command,verbose
	aliases = gen_aliases verbose

	if verbose
		puts "Sending following command to TinyURL: " + command
	end

	enc_command=CGI.escape(command)
	
	aliases.each { |aliasx|
		res=shorten(BASE_SITE + "/" + Time.new.to_i.to_s + "/" + "?" + enc_command, aliasx, verbose)
		if res
			if verbose
				puts "Command sent"
			end

			return true
		end
	}

	puts "Failed to find unique alias, please try again in next 10 minute timeslot."
	return false
end
